Index: /trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1413)
@@ -3370,4 +3329,112 @@
                 bBestUseSDC = false;
 #endif
+                xSetIntraResultLumaQT( pcRecoYuv, tuRecurseWithPU );
+
+                if (pps.getPpsRangeExtension().getCrossComponentPredictionEnabledFlag())
+                {
+                  const Int xOffset = tuRecurseWithPU.getRect( COMPONENT_Y ).x0;
+                  const Int yOffset = tuRecurseWithPU.getRect( COMPONENT_Y ).y0;
+                  for (UInt storedResidualIndex = 0; storedResidualIndex < NUMBER_OF_STORED_RESIDUAL_TYPES; storedResidualIndex++)
+                  {
+                    if (bMaintainResidual[storedResidualIndex])
+                    {
+                      xStoreCrossComponentPredictionResult(resiLuma[storedResidualIndex], resiLumaPU[storedResidualIndex], tuRecurseWithPU, xOffset, yOffset, MAX_CU_SIZE, MAX_CU_SIZE );
+                    }
+                  }
+                }
+
+                UInt uiQPartNum = tuRecurseWithPU.GetAbsPartIdxNumParts();
+
+                ::memcpy( m_puhQTTempTrIdx,  pcCU->getTransformIdx()       + uiPartOffset, uiQPartNum * sizeof( UChar ) );
+                for (UInt component = 0; component < numberValidComponents; component++)
+                {
+                  const ComponentID compID = ComponentID(component);
+                  ::memcpy( m_puhQTTempCbf[compID], pcCU->getCbf( compID  ) + uiPartOffset, uiQPartNum * sizeof( UChar ) );
+                  ::memcpy( m_puhQTTempTransformSkipFlag[compID],  pcCU->getTransformSkip(compID)  + uiPartOffset, uiQPartNum * sizeof( UChar ) );
+                }
+#if NH_3D
+              }
+#endif
+            }
+#if HHI_RQT_INTRA_SPEEDUP_MOD
+            else if( dPUCost < dSecondBestPUCost )
+            {
+              uiSecondBestMode  = uiOrgMode;
+              dSecondBestPUCost = dPUCost;
+            }
+#endif
+
+#if NH_3D
+          }
+        } // SDC residual loop
+      } // SDC loop
+#endif
+#if NH_MV
+      D_DEC_INDENT( g_traceModeCheck ); 
+#endif
+    } // Mode loop
+
+#if HHI_RQT_INTRA_SPEEDUP
+#if HHI_RQT_INTRA_SPEEDUP_MOD
+    for( UInt ui =0; ui < 2; ++ui )
+#endif
+    {
+#if HHI_RQT_INTRA_SPEEDUP_MOD
+      UInt uiOrgMode   = ui ? uiSecondBestMode  : uiBestPUMode;
+      if( uiOrgMode == MAX_UINT )
+      {
+        break;
+      }
+#else
+      UInt uiOrgMode = uiBestPUMode;
+#endif
+
+
+#if ENVIRONMENT_VARIABLE_DEBUG_AND_TEST
+      if (DebugOptionList::ForceLumaMode.isSet())
+      {
+        uiOrgMode = DebugOptionList::ForceLumaMode.getInt();
+      }
+#endif
+
+      pcCU->setIntraDirSubParts ( CHANNEL_TYPE_LUMA, uiOrgMode, uiPartOffset, uiDepth + uiInitTrDepth );
+#if NH_3D
+      pcCU->setSDCFlagSubParts(false, uiPartOffset, uiDepth + uiInitTrDepth);
+#endif
+
+      DEBUG_STRING_NEW(sModeTree)
+
+      // set context models
+      m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST] );
+
+      // determine residual for partition
+#if NH_3D_VSO
+      Dist       uiPUDistY = 0;
+#else
+      Distortion uiPUDistY = 0;
+#endif
+      Double     dPUCost   = 0.0;
+#if NH_3D_VSO // M37  //check if necessary
+      // reset Model
+      if( m_pcRdCost->getUseRenModel() )
+      {
+        m_pcRdCost->setRenModelData( pcCU, uiPartOffset, pcOrgYuv, &tuRecurseWithPU );        
+      }
+#endif
+
+      xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, false, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sModeTree));
+
+      // check r-d cost
+      if( dPUCost < dBestPUCost )
+      {
+        DEBUG_STRING_SWAP(sPU, sModeTree)
+        uiBestPUMode  = uiOrgMode;
+        uiBestPUDistY = uiPUDistY;
+        dBestPUCost   = dPUCost;
+#if NH_3D
+        bBestUseSDC   = false;
+#endif
+
+
         xSetIntraResultLumaQT( pcRecoYuv, tuRecurseWithPU );
 
@@ -3385,7 +3452,7 @@
         }
 
-        UInt uiQPartNum = tuRecurseWithPU.GetAbsPartIdxNumParts();
-
+        const UInt uiQPartNum = tuRecurseWithPU.GetAbsPartIdxNumParts();
         ::memcpy( m_puhQTTempTrIdx,  pcCU->getTransformIdx()       + uiPartOffset, uiQPartNum * sizeof( UChar ) );
+
         for (UInt component = 0; component < numberValidComponents; component++)
         {
@@ -3394,113 +3461,4 @@
           ::memcpy( m_puhQTTempTransformSkipFlag[compID],  pcCU->getTransformSkip(compID)  + uiPartOffset, uiQPartNum * sizeof( UChar ) );
         }
-#if NH_3D_SDC_INTRA
-        }
-#endif
-      }
-#if HHI_RQT_INTRA_SPEEDUP_MOD
-      else if( dPUCost < dSecondBestPUCost )
-      {
-        uiSecondBestMode  = uiOrgMode;
-        dSecondBestPUCost = dPUCost;
-      }
-#endif
-#if NH_3D_ENC_DEPTH
-          }
-#endif
-#if NH_3D_SDC_INTRA
-        } // SDC residual loop
-      } // SDC loop
-#endif
-#if NH_MV
-      D_DEC_INDENT( g_traceModeCheck ); 
-#endif
-    } // Mode loop
-
-#if HHI_RQT_INTRA_SPEEDUP
-#if HHI_RQT_INTRA_SPEEDUP_MOD
-    for( UInt ui =0; ui < 2; ++ui )
-#endif
-    {
-#if HHI_RQT_INTRA_SPEEDUP_MOD
-      UInt uiOrgMode   = ui ? uiSecondBestMode  : uiBestPUMode;
-      if( uiOrgMode == MAX_UINT )
-      {
-        break;
-      }
-#else
-      UInt uiOrgMode = uiBestPUMode;
-#endif
-
-
-#if ENVIRONMENT_VARIABLE_DEBUG_AND_TEST
-      if (DebugOptionList::ForceLumaMode.isSet())
-      {
-        uiOrgMode = DebugOptionList::ForceLumaMode.getInt();
-      }
-#endif
-
-      pcCU->setIntraDirSubParts ( CHANNEL_TYPE_LUMA, uiOrgMode, uiPartOffset, uiDepth + uiInitTrDepth );
-#if NH_3D_SDC_INTRA
-      pcCU->setSDCFlagSubParts(false, uiPartOffset, uiDepth + uiInitTrDepth);
-#endif
-
-      DEBUG_STRING_NEW(sModeTree)
-
-      // set context models
-      m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST] );
-
-      // determine residual for partition
-#if NH_3D_VSO
-      Dist       uiPUDistY = 0;
-#else
-      Distortion uiPUDistY = 0;
-#endif
-      Double     dPUCost   = 0.0;
-#if NH_3D_VSO // M37  //check if necessary
-      // reset Model
-      if( m_pcRdCost->getUseRenModel() )
-      {
-        m_pcRdCost->setRenModelData( pcCU, uiPartOffset, pcOrgYuv, &tuRecurseWithPU );        
-      }
-#endif
-
-      xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, false, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sModeTree));
-
-      // check r-d cost
-      if( dPUCost < dBestPUCost )
-      {
-        DEBUG_STRING_SWAP(sPU, sModeTree)
-        uiBestPUMode  = uiOrgMode;
-        uiBestPUDistY = uiPUDistY;
-        dBestPUCost   = dPUCost;
-#if NH_3D_SDC_INTRA
-        bBestUseSDC   = false;
-#endif
-
-
-        xSetIntraResultLumaQT( pcRecoYuv, tuRecurseWithPU );
-
-        if (pps.getPpsRangeExtension().getCrossComponentPredictionEnabledFlag())
-        {
-          const Int xOffset = tuRecurseWithPU.getRect( COMPONENT_Y ).x0;
-          const Int yOffset = tuRecurseWithPU.getRect( COMPONENT_Y ).y0;
-          for (UInt storedResidualIndex = 0; storedResidualIndex < NUMBER_OF_STORED_RESIDUAL_TYPES; storedResidualIndex++)
-          {
-            if (bMaintainResidual[storedResidualIndex])
-            {
-              xStoreCrossComponentPredictionResult(resiLuma[storedResidualIndex], resiLumaPU[storedResidualIndex], tuRecurseWithPU, xOffset, yOffset, MAX_CU_SIZE, MAX_CU_SIZE );
-            }
-          }
-        }
-
-        const UInt uiQPartNum = tuRecurseWithPU.GetAbsPartIdxNumParts();
-        ::memcpy( m_puhQTTempTrIdx,  pcCU->getTransformIdx()       + uiPartOffset, uiQPartNum * sizeof( UChar ) );
-
-        for (UInt component = 0; component < numberValidComponents; component++)
-        {
-          const ComponentID compID = ComponentID(component);
-          ::memcpy( m_puhQTTempCbf[compID], pcCU->getCbf( compID  ) + uiPartOffset, uiQPartNum * sizeof( UChar ) );
-          ::memcpy( m_puhQTTempTransformSkipFlag[compID],  pcCU->getTransformSkip(compID)  + uiPartOffset, uiQPartNum * sizeof( UChar ) );
-        }
       }
     } // Mode loop
@@ -3511,5 +3469,5 @@
     //--- update overall distortion ---
     uiOverallDistY += uiBestPUDistY;
-#if NH_3D_SDC_INTRA
+#if NH_3D
     if( bBestUseSDC )
     {
@@ -3533,5 +3491,5 @@
       ::memcpy( pcCU->getCbf( compID  ) + uiPartOffset, m_puhQTTempCbf[compID], uiQPartNum * sizeof( UChar ) );
       ::memcpy( pcCU->getTransformSkip( compID  ) + uiPartOffset, m_puhQTTempTransformSkipFlag[compID ], uiQPartNum * sizeof( UChar ) );
-#if NH_3D_SDC_INTRA
+#if NH_3D
     }
 #endif
@@ -3570,5 +3528,5 @@
     //=== update PU data ====
     pcCU->setIntraDirSubParts     ( CHANNEL_TYPE_LUMA, uiBestPUMode, uiPartOffset, uiDepth + uiInitTrDepth );
-#if NH_3D_SDC_INTRA
+#if NH_3D
     pcCU->setSDCFlagSubParts          ( bBestUseSDC, uiPartOffset, uiDepth + uiInitTrDepth );
 #endif
@@ -3895,8 +3853,6 @@
                             iWidth, iHeight, m_pcEncCfg->getUseHADME() && (pcCU->getCUTransquantBypass(iPartIdx) == 0) );
 
-#if NH_3D_IC
+#if NH_3D
   cDistParam.bUseIC = false;
-#endif
-#if NH_3D_SDC_INTER
   cDistParam.bUseSDCMRSAD = false;
 #endif
@@ -3907,9 +3863,6 @@
 //! estimation of best merge coding
 Void TEncSearch::xMergeEstimation( TComDataCU* pcCU, TComYuv* pcYuvOrg, Int iPUIdx, UInt& uiInterDir, TComMvField* pacMvField, UInt& uiMergeIndex, Distortion& ruiCost, TComMvField* cMvFieldNeighbours, UChar* uhInterDirNeighbours, Int& numValidMergeCand 
-#if NH_3D_VSP
-                                 , Int* vspFlag
-#endif
-#if NH_3D_SPIVMP
-                                 , Bool* pbSPIVMPFlag, TComMvField* pcMvFieldSP, UChar* puhInterDirSP
+#if NH_3D
+                                 , Int* vspFlag, Bool* pbSPIVMPFlag, TComMvField* pcMvFieldSP, UChar* puhInterDirSP
 #endif
 )
@@ -3926,5 +3879,5 @@
   UInt uiDepth = pcCU->getDepth( uiAbsPartIdx );
 
-#if NH_3D_DBBP
+#if NH_3D
   DbbpTmpData* pDBBPTmpData = pcCU->getDBBPTmpData();
   if( pcCU->getDBBPFlag(0) )
@@ -3958,5 +3911,5 @@
 
   PartSize partSize = pcCU->getPartitionSize( 0 );
-#if NH_3D_DBBP
+#if NH_3D
   if ( pcCU->getSlice()->getPPS()->getLog2ParallelMergeLevelMinus2() && partSize != SIZE_2Nx2N && pcCU->getWidth( 0 ) <= 8 && pcCU->getDBBPFlag(0) == false )
 #else
@@ -3967,26 +3920,30 @@
     {
       pcCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uiDepth ); // temporarily set
-#if NH_3D_MLC
+#if NH_3D
       pcCU->initAvailableFlags();
+#if MCTS_ENC_CHECK
+      UInt numSpatialMergeCandidates = 0;
+      pcCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates );
+      if (m_pcEncCfg->getTMCTSSEITileConstraint() && pcCU->isLastColumnCTUInTile())
+      {
+        numValidMergeCand = numSpatialMergeCandidates;
+      }
+#else 
       pcCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours, numValidMergeCand );
-      pcCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours
-#if NH_3D_SPIVMP
-        , pcMvFieldSP, puhInterDirSP
-#endif
-        , numValidMergeCand
-        );
-
-      pcCU->buildMCL( cMvFieldNeighbours,uhInterDirNeighbours
-#if NH_3D_VSP
-        , vspFlag
-#endif
-#if NH_3D_SPIVMP
-        , pbSPIVMPFlag
-#endif
-        , numValidMergeCand
-        );
+#endif
+      pcCU->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours , pcMvFieldSP, puhInterDirSP, numValidMergeCand );
+      pcCU->buildMCL( cMvFieldNeighbours,uhInterDirNeighbours , vspFlag, pbSPIVMPFlag, numValidMergeCand );
+#else
+#if MCTS_ENC_CHECK
+      UInt numSpatialMergeCandidates = 0;
+      pcCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates );
+      if (m_pcEncCfg->getTMCTSSEITileConstraint() && pcCU->isLastColumnCTUInTile())
+      {
+        numValidMergeCand = numSpatialMergeCandidates;
+      }
 #else
       pcCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours,uhInterDirNeighbours, numValidMergeCand );
 #endif
+#endif
       pcCU->setPartSizeSubParts( partSize, 0, uiDepth ); // restore
     }
@@ -3994,31 +3951,35 @@
   else
   {
-#if NH_3D_MLC
+#if NH_3D
     pcCU->initAvailableFlags();
+#if MCTS_ENC_CHECK
+    UInt numSpatialMergeCandidates = 0;
+    pcCU->getInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates );
+    if (m_pcEncCfg->getTMCTSSEITileConstraint() && pcCU->isLastColumnCTUInTile())
+    {
+      numValidMergeCand = numSpatialMergeCandidates;
+    }
+#else 
     pcCU->getInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
-    pcCU->xGetInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours
-#if NH_3D_SPIVMP
-      , pcMvFieldSP, puhInterDirSP
-#endif
-      , numValidMergeCand
-      );
-
-    pcCU->buildMCL( cMvFieldNeighbours, uhInterDirNeighbours
-#if NH_3D_VSP
-      , vspFlag
-#endif
-#if NH_3D_SPIVMP
-      , pbSPIVMPFlag
-#endif
-      , numValidMergeCand
-      );
+#endif
+    pcCU->xGetInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, pcMvFieldSP, puhInterDirSP , numValidMergeCand      );
+    pcCU->buildMCL( cMvFieldNeighbours, uhInterDirNeighbours , vspFlag, pbSPIVMPFlag, numValidMergeCand );
+#else
+#if MCTS_ENC_CHECK
+    UInt numSpatialMergeCandidates = 0;
+    pcCU->getInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates );
+    if (m_pcEncCfg->getTMCTSSEITileConstraint() && pcCU->isLastColumnCTUInTile())
+    {
+      numValidMergeCand = numSpatialMergeCandidates;
+    }
 #else
     pcCU->getInterMergeCandidates( uiAbsPartIdx, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
 #endif
+#endif
   }
 
   xRestrictBipredMergeCand( pcCU, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
 
-#if NH_3D_DBBP
+#if NH_3D
   if( pcCU->getDBBPFlag(0) )
   {
@@ -4046,9 +4007,7 @@
 
     PartSize ePartSize = pcCU->getPartitionSize( 0 );
-#if NH_3D_VSP
+#if NH_3D
     pcCU->setVSPFlagSubParts( vspFlag[uiMergeCand], uiAbsPartIdx, iPUIdx, pcCU->getDepth( uiAbsPartIdx ) );
-#endif
-
-#if NH_3D_SPIVMP
+
     pcCU->setSPIVMPFlagSubParts( pbSPIVMPFlag[uiMergeCand], uiAbsPartIdx, iPUIdx, pcCU->getDepth( uiAbsPartIdx )); 
     if (pbSPIVMPFlag[uiMergeCand])
@@ -4068,11 +4027,5 @@
     }
     else
-#endif
-#if NH_3D_VSP
-#if NH_3D_DBBP
       if ( vspFlag[uiMergeCand] && !pcCU->getDBBPFlag(0) )
-#else
-      if ( vspFlag[uiMergeCand] )
-#endif
       {
         UInt partAddr;
@@ -4103,12 +4056,9 @@
       {
 #endif
-
-    pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], ePartSize, uiAbsPartIdx, 0, iPUIdx );
-    pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], ePartSize, uiAbsPartIdx, 0, iPUIdx );
-#if NH_3D_VSP
-      }
-#endif
-
-
+        pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvField( cMvFieldNeighbours[0 + 2*uiMergeCand], ePartSize, uiAbsPartIdx, 0, iPUIdx );
+        pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand], ePartSize, uiAbsPartIdx, 0, iPUIdx );
+#if NH_3D
+      }
+#endif
     xGetInterPredictionError( pcCU, pcYuvOrg, iPUIdx, uiCostCand, m_pcEncCfg->getUseHADME() );
     uiBitsCand = uiMergeCand + 1;
@@ -4233,5 +4183,5 @@
   Distortion   biPDistTemp = std::numeric_limits<Distortion>::max();
 
-#if NH_3D_IV_MERGE
+#if NH_3D
   TComMvField cMvFieldNeighbours[MRG_MAX_NUM_CANDS_MEM << 1]; // double length for mv of both lists
   UChar uhInterDirNeighbours[MRG_MAX_NUM_CANDS_MEM];
@@ -4272,5 +4222,5 @@
 
     pcCU->getPartIndexAndSize( iPartIdx, uiPartAddr, iRoiWidth, iRoiHeight );
-#if NH_3D_VSP
+#if NH_3D
     pcCU->setVSPFlagSubParts( 0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr) );
 #endif
@@ -4629,5 +4579,5 @@
     } // end if bTestNormalMC
 #endif
-#if NH_3D_DBBP
+#if NH_3D
     // test merge mode for DBBP (2Nx2N)
     if ( pcCU->getPartitionSize( uiPartAddr ) != SIZE_2Nx2N || pcCU->getDBBPFlag(0) )
@@ -4672,5 +4622,5 @@
       Distortion uiMRGCost = std::numeric_limits<Distortion>::max();
 
-#if NH_3D_VSP
+#if NH_3D
       Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
       memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
@@ -4680,6 +4630,5 @@
       pcCU->getPartIndexAndSize( iPartIdx, uiAbsPartIdx, iWidth, iHeight );
       DisInfo OriginalDvInfo = pcCU->getDvInfo(uiAbsPartIdx);
-#endif
-#if NH_3D_SPIVMP
+
       Bool bSPIVMPFlag[MRG_MAX_NUM_CANDS_MEM];
       memset(bSPIVMPFlag, false, sizeof(Bool)*MRG_MAX_NUM_CANDS_MEM);
@@ -4690,9 +4639,6 @@
 #endif
       xMergeEstimation( pcCU, pcOrgYuv, iPartIdx, uiMRGInterDir, cMRGMvField, uiMRGIndex, uiMRGCost, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand
-#if NH_3D_VSP
-                      , vspFlag
-#endif
-#if NH_3D_SPIVMP
-                      , bSPIVMPFlag, pcMvFieldSP, puhInterDirSP
+#if NH_3D
+                      , vspFlag , bSPIVMPFlag, pcMvFieldSP, puhInterDirSP
 #endif 
                       );
@@ -4703,8 +4649,6 @@
         pcCU->setMergeFlagSubParts ( true,          uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
         pcCU->setMergeIndexSubParts( uiMRGIndex,    uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-#if NH_3D_VSP
+#if NH_3D
         pcCU->setVSPFlagSubParts( vspFlag[uiMRGIndex], uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-#endif
-#if NH_3D_SPIVMP
         pcCU->setSPIVMPFlagSubParts(bSPIVMPFlag[uiMRGIndex], uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );  
         if (bSPIVMPFlag[uiMRGIndex]!=0)
@@ -4728,59 +4672,50 @@
         }
         else
-#endif
-#if NH_3D_VSP
-#if NH_3D_DBBP
-        if ( vspFlag[uiMRGIndex] && !pcCU->getDBBPFlag(uiPartAddr) )
-#else
-        if ( vspFlag[uiMRGIndex] )
-#endif
-        {
-          UInt partAddrTemp;
-          Int vspSize;
-          Int width, height;
-          pcCU->getPartIndexAndSize( iPartIdx, partAddrTemp, width, height ); // true or pcCU->getTotalNumPart()==256
-          if( uiMRGInterDir & 0x01 )
+          if ( vspFlag[uiMRGIndex] && !pcCU->getDBBPFlag(uiPartAddr) )
           {
-            pcCU->setMvFieldPUForVSP( pcCU, partAddrTemp, width, height, REF_PIC_LIST_0, cMRGMvField[0].getRefIdx(), vspSize );
-            pcCU->setVSPFlag( partAddrTemp, vspSize );
+            UInt partAddrTemp;
+            Int vspSize;
+            Int width, height;
+            pcCU->getPartIndexAndSize( iPartIdx, partAddrTemp, width, height ); // true or pcCU->getTotalNumPart()==256
+            if( uiMRGInterDir & 0x01 )
+            {
+              pcCU->setMvFieldPUForVSP( pcCU, partAddrTemp, width, height, REF_PIC_LIST_0, cMRGMvField[0].getRefIdx(), vspSize );
+              pcCU->setVSPFlag( partAddrTemp, vspSize );
+            }
+            else
+            {
+              pcCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMRGMvField[0], ePartSize, uiPartAddr, 0, iPartIdx );
+            }
+            if( uiMRGInterDir & 0x02 )
+            {
+              pcCU->setMvFieldPUForVSP( pcCU, partAddrTemp, width, height, REF_PIC_LIST_1, cMRGMvField[1].getRefIdx(), vspSize );
+              pcCU->setVSPFlag( partAddrTemp, vspSize );
+            }
+            else
+            {
+              pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMRGMvField[1], ePartSize, uiPartAddr, 0, iPartIdx );
+            }
+            pcCU->setInterDirSubParts  ( uiMRGInterDir, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
           }
           else
           {
+#endif
+            pcCU->setInterDirSubParts  ( uiMRGInterDir, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
             pcCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMRGMvField[0], ePartSize, uiPartAddr, 0, iPartIdx );
+            pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMRGMvField[1], ePartSize, uiPartAddr, 0, iPartIdx );
+#if NH_3D
           }
-          if( uiMRGInterDir & 0x02 )
-          {
-            pcCU->setMvFieldPUForVSP( pcCU, partAddrTemp, width, height, REF_PIC_LIST_1, cMRGMvField[1].getRefIdx(), vspSize );
-            pcCU->setVSPFlag( partAddrTemp, vspSize );
-          }
-          else
-          {
-            pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMRGMvField[1], ePartSize, uiPartAddr, 0, iPartIdx );
-          }
-          pcCU->setInterDirSubParts  ( uiMRGInterDir, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-        }
-        else
-          {
-#endif
-        pcCU->setInterDirSubParts  ( uiMRGInterDir, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-        pcCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMRGMvField[0], ePartSize, uiPartAddr, 0, iPartIdx );
-        pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMRGMvField[1], ePartSize, uiPartAddr, 0, iPartIdx );
-#if NH_3D_VSP
-          }
-#endif
-#if H_3D
-          }
-#endif
-        pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvd    ( cMvZero,            ePartSize, uiPartAddr, 0, iPartIdx );
-        pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvd    ( cMvZero,            ePartSize, uiPartAddr, 0, iPartIdx );
-
-        pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
-        pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
-        pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
-        pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+#endif
+          pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvd    ( cMvZero,            ePartSize, uiPartAddr, 0, iPartIdx );
+          pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvd    ( cMvZero,            ePartSize, uiPartAddr, 0, iPartIdx );
+
+          pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+          pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_0, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+          pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
+          pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_1, uiPartAddr, iPartIdx, pcCU->getDepth(uiPartAddr));
       }
       else
       {
-#if NH_3D_SPIVMP        
+#if NH_3D
         pcCU->setSPIVMPFlagSubParts(0, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) ); 
 #endif
@@ -4788,5 +4723,5 @@
         pcCU->setMergeFlagSubParts( false,        uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
         pcCU->setInterDirSubParts ( uiMEInterDir, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
-#if NH_3D_VSP
+#if NH_3D
         pcCU->setVSPFlagSubParts ( 0,             uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
         pcCU->setDvInfoSubParts(OriginalDvInfo, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
@@ -4795,9 +4730,17 @@
         pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMEMvField[1], ePartSize, uiPartAddr, 0, iPartIdx );
       }
-#if NH_3D_SPIVMP
+#if NH_3D
       delete[] pcMvFieldSP;
       delete[] puhInterDirSP;
 #endif
     }
+
+#if MCTS_ENC_CHECK
+    if (m_pcEncCfg->getTMCTSSEITileConstraint() && (!checkTMctsMvp(pcCU, iPartIdx)))
+    {
+      pcCU->setTMctsMvpIsValid(false);
+      return;
+    }
+#endif
 
     //  MC
@@ -4834,4 +4777,6 @@
   Int        iRoiWidth, iRoiHeight;
   Int        i;
+  Int        minMVPCand;
+  Int        maxMVPCand;
 
   pcCU->getPartIndexAndSize( uiPartIdx, uiPartAddr, iRoiWidth, iRoiHeight );
@@ -4840,5 +4785,5 @@
   {
 
-#if NH_3D_DBBP
+#if NH_3D
     DbbpTmpData* pDBBPTmpData = pcCU->getDBBPTmpData();
     if( pcCU->getDBBPFlag(0) )
@@ -4872,5 +4817,5 @@
 
     pcCU->fillMvpCand( uiPartIdx, uiPartAddr, eRefPicList, iRefIdx, pcAMVPInfo );
-#if NH_3D_DBBP
+#if NH_3D
     if( pcCU->getDBBPFlag(0) )
     {
@@ -4889,6 +4834,26 @@
 
   // initialize Mvp index & Mvp
+#if MCTS_ENC_CHECK
+  if (m_pcEncCfg->getTMCTSSEITileConstraint() && pcCU->isLastColumnCTUInTile() && (pcAMVPInfo->numSpatialMVPCandidates < pcAMVPInfo->iN))
+  {
+    iBestIdx    = (pcAMVPInfo->numSpatialMVPCandidates == 0) ? 1 : 0;
+    cBestMv     = pcAMVPInfo->m_acMvCand[(pcAMVPInfo->numSpatialMVPCandidates == 0) ? 1 : 0];
+    minMVPCand  = (pcAMVPInfo->numSpatialMVPCandidates == 0) ? 1 : 0;
+    maxMVPCand  = (pcAMVPInfo->numSpatialMVPCandidates == 0) ? pcAMVPInfo->iN : 1;
+  }
+  else
+  {
+    iBestIdx = 0;
+    cBestMv  = pcAMVPInfo->m_acMvCand[0];
+    minMVPCand  = 0;
+    maxMVPCand  = pcAMVPInfo->iN;
+  }
+#else
   iBestIdx = 0;
   cBestMv  = pcAMVPInfo->m_acMvCand[0];
+  minMVPCand  = 0;
+  maxMVPCand  = pcAMVPInfo->iN;
+#endif
+
   if (pcAMVPInfo->iN <= 1)
   {
@@ -4922,5 +4887,5 @@
   m_cYuvPredTemp.clear();
   //-- Check Minimum Cost.
-  for ( i = 0 ; i < pcAMVPInfo->iN; i++)
+  for ( i = minMVPCand ; i < maxMVPCand; i++)
   {
 #if NH_MV
@@ -5064,5 +5029,17 @@
   Int iBestMvBits = iOrgMvBits;
 
+#if MCTS_ENC_CHECK
+  Int minMVPCand = 0;
+  Int maxMVPCand = pcAMVPInfo->iN;
+
+  if (m_pcEncCfg->getTMCTSSEITileConstraint() && pcCU->isLastColumnCTUInTile())
+  {
+    minMVPCand = (pcAMVPInfo->numSpatialMVPCandidates == 0) ? 1 : 0;
+    maxMVPCand = (pcAMVPInfo->numSpatialMVPCandidates == 0) ? pcAMVPInfo->iN : 1;
+  }
+  for (Int iMVPIdx = minMVPCand; iMVPIdx < maxMVPCand; iMVPIdx++)
+#else
   for (Int iMVPIdx = 0; iMVPIdx < pcAMVPInfo->iN; iMVPIdx++)
+#endif
   {
     if (iMVPIdx == riMVPIdx)
@@ -5114,5 +5091,5 @@
   pcCU->clipMv( cMvCand );
 
-#if NH_3D_IC
+#if NH_3D
   Bool bICFlag = pcCU->getICFlag( uiPartAddr ) && ( pcCU->getSlice()->getViewIndex() != pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getViewIndex() );
 #endif
@@ -5122,5 +5099,5 @@
   {
     xPredInterBlk( COMPONENT_Y, pcCU, pcPicYuvRef, uiPartAddr, &cMvCand, iSizeX, iSizeY, pcTemplateCand, true, pcCU->getSlice()->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) 
-#if NH_3D_ARP
+#if NH_3D
       , false //add this for IC, otherwise, it could be removed
 #endif
@@ -5130,11 +5107,7 @@
   {
     xPredInterBlk( COMPONENT_Y, pcCU, pcPicYuvRef, uiPartAddr, &cMvCand, iSizeX, iSizeY, pcTemplateCand, false, pcCU->getSlice()->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) 
-#if NH_3D_ARP
-      , false
-#endif
-#if NH_3D_IC
-    , bICFlag
-#endif
-
+#if NH_3D
+      , false, bICFlag
+#endif
 );
   }
@@ -5175,6 +5148,5 @@
 
   Int           iSrchRng      = ( bBi ? m_bipredSearchRange : m_iSearchRange );
-  TComPattern   tmpPattern;
-  TComPattern*  pcPatternKey  = &tmpPattern;
+  TComPattern   cPattern;
 
   Double        fWeight       = 1.0;
@@ -5182,10 +5154,8 @@
   pcCU->getPartIndexAndSize( iPartIdx, uiPartAddr, iRoiWidth, iRoiHeight );
 
-#if NH_3D_IC
+#if NH_3D
   Bool bICFlag = pcCU->getICFlag( uiPartAddr ) && ( pcCU->getSlice()->getViewIndex() != pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->getViewIndex() );
-  pcPatternKey->setICFlag( bICFlag );
-#endif
-#if NH_3D_SDC_INTER
-   pcPatternKey->setSDCMRSADFlag( pcCU->getSlice()->getInterSdcFlag() );
+  cPattern.setICFlag( bICFlag );
+  cPattern.setSDCMRSADFlag( pcCU->getSlice()->getInterSdcFlag() );
 #endif
 
@@ -5204,10 +5174,25 @@
 
   //  Search key pattern initialization
-  pcPatternKey->initPattern( pcYuv->getAddr  ( COMPONENT_Y, uiPartAddr ),
+#if MCTS_ENC_CHECK
+  Int roiPosX, roiPosY; 
+  Int roiW, roiH;
+  pcCU->getPartPosition(iPartIdx, roiPosX, roiPosY, roiW, roiH);
+  assert(roiW == iRoiWidth);
+  assert(roiH == iRoiHeight);
+  cPattern.initPattern( pcYuv->getAddr(COMPONENT_Y, uiPartAddr),
+                        iRoiWidth,
+                        iRoiHeight,
+                        pcYuv->getStride(COMPONENT_Y),
+                        pcCU->getSlice()->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA),
+                        roiPosX,
+                        roiPosY);
+  xInitTileBorders(pcCU, &cPattern);
+#else
+  cPattern.initPattern( pcYuv->getAddr  ( COMPONENT_Y, uiPartAddr ),
                              iRoiWidth,
                              iRoiHeight,
                              pcYuv->getStride(COMPONENT_Y),
                              pcCU->getSlice()->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) );
-
+#endif
   Pel*        piRefY      = pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->getPicYuvRec()->getAddr( COMPONENT_Y, pcCU->getCtuRsAddr(), pcCU->getZorderIdxInCtu() + uiPartAddr );
   Int         iRefStride  = pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->getPicYuvRec()->getStride(COMPONENT_Y);
@@ -5220,9 +5205,17 @@
   if ( bBi )
   {
+#if MCTS_ENC_CHECK
+    xSetSearchRange(pcCU, rcMv, iSrchRng, cMvSrchRngLT, cMvSrchRngRB, &cPattern);
+#else
     xSetSearchRange   ( pcCU, rcMv   , iSrchRng, cMvSrchRngLT, cMvSrchRngRB );
+#endif
   }
   else
   {
+#if MCTS_ENC_CHECK
+    xSetSearchRange(pcCU, cMvPred, iSrchRng, cMvSrchRngLT, cMvSrchRngRB, &cPattern);
+#else
     xSetSearchRange   ( pcCU, cMvPred, iSrchRng, cMvSrchRngLT, cMvSrchRngRB );
+#endif
   }
 
@@ -5230,5 +5223,5 @@
 
   m_pcRdCost->setPredictor  ( *pcMvPred );
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( pcCU->getSlice()->getIsDepth() )
   {
@@ -5239,5 +5232,5 @@
 #endif
     m_pcRdCost->setCostScale  ( 2 );    
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   }
 #endif
@@ -5248,10 +5241,10 @@
   if ( (m_motionEstimationSearchMethod==MESEARCH_FULL) || bBi )
   {
-    xPatternSearch      ( pcPatternKey, piRefY, iRefStride, &cMvSrchRngLT, &cMvSrchRngRB, rcMv, ruiCost );
+    xPatternSearch      ( &cPattern, piRefY, iRefStride, &cMvSrchRngLT, &cMvSrchRngRB, rcMv, ruiCost );
   }
   else
   {
     rcMv = *pcMvPred;
-#if NH_MV_FIX_VERT_MV_REST
+#if NH_MV
     if ( m_vertRestriction )
     {
@@ -5267,5 +5260,5 @@
       pIntegerMv2Nx2NPred = &(m_integerMv2Nx2N[eRefPicList][iRefIdxPred]);
     }
-    xPatternSearchFast  ( pcCU, pcPatternKey, piRefY, iRefStride, &cMvSrchRngLT, &cMvSrchRngRB, rcMv, ruiCost, pIntegerMv2Nx2NPred );
+    xPatternSearchFast  ( pcCU, &cPattern, piRefY, iRefStride, &cMvSrchRngLT, &cMvSrchRngRB, rcMv, ruiCost, pIntegerMv2Nx2NPred );
     if (pcCU->getPartitionSize(0) == SIZE_2Nx2N)
     {
@@ -5275,23 +5268,23 @@
 
   m_pcRdCost->selectMotionLambda( true, 0, pcCU->getCUTransquantBypass(uiPartAddr) );
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( ! pcCU->getSlice()->getIsDepth() )
   {
 #endif
-  m_pcRdCost->setCostScale ( 1 );
-
-  const Bool bIsLosslessCoded = pcCU->getCUTransquantBypass(uiPartAddr) != 0;
-  xPatternSearchFracDIF( bIsLosslessCoded, pcPatternKey, piRefY, iRefStride, &rcMv, cMvHalf, cMvQter, ruiCost );
-
-  m_pcRdCost->setCostScale( 0 );
-  rcMv <<= 2;
-  rcMv += (cMvHalf <<= 1);
-  rcMv +=  cMvQter;
-#if NH_3D_INTEGER_MV_DEPTH
+    m_pcRdCost->setCostScale ( 1 );
+
+    const Bool bIsLosslessCoded = pcCU->getCUTransquantBypass(uiPartAddr) != 0;
+    xPatternSearchFracDIF( bIsLosslessCoded, &cPattern, piRefY, iRefStride, &rcMv, cMvHalf, cMvQter, ruiCost );
+
+    m_pcRdCost->setCostScale( 0 );
+    rcMv <<= 2;
+    rcMv += (cMvHalf <<= 1);
+    rcMv +=  cMvQter;
+#if NH_3D
   }
 #endif
 
   UInt uiMvBits = m_pcRdCost->getBitsOfVectorWithPredictor( rcMv.getHor(), rcMv.getVer() );
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( pcCU->getSlice()->getIsDepth() )
   {
